org.eclipse.wst.jsdt.chromium.debug.core.model

## Class ValueBase

- java.lang.Object
- - PlatformObject
  - - org.eclipse.wst.jsdt.chromium.debug.core.model.DebugElementImpl
    - - org.eclipse.wst.jsdt.chromium.debug.core.model.DebugElementImpl.WithConnectedBase
      - - org.eclipse.wst.jsdt.chromium.debug.core.model.DebugElementImpl.WithSuspendedBase
        - - org.eclipse.wst.jsdt.chromium.debug.core.model.DebugElementImpl.WithEvaluateBase
          - - org.eclipse.wst.jsdt.chromium.debug.core.model.DebugElementImpl.WithEvaluate
            - - org.eclipse.wst.jsdt.chromium.debug.core.model.ValueBase

Direct Known Subclasses:
  ValueBase.ErrorMessageValue, ValueBase.ValueWithLazyVariables

    public abstract class ValueBase
    extends DebugElementImpl.WithEvaluate

A base implementation of all Chromium values. This class merely adds new interface, not behavior. The actual class may be based on `JsValue` (regular case) or other data sources.

### Nested Class Summary

Nested Classes
`static class` `ValueBase.ErrorMessageValue` Wraps string error message as a Value.
`static class` `ValueBase.ValueWithLazyVariables` A base implementation of Value that lazily calculates its inner variables.

### Nested classes/interfaces inherited from class org.eclipse.wst.jsdt.chromium.debug.core.model.DebugElementImpl

`DebugElementImpl.WithConnected, DebugElementImpl.WithConnectedBase, DebugElementImpl.WithEvaluate, DebugElementImpl.WithEvaluateBase, DebugElementImpl.WithSuspended, DebugElementImpl.WithSuspendedBase`

### Constructor Summary

Constructors
`protected` `ValueBase(EvaluateContext evaluateContext)`

### Method Summary

All Methods Static Methods Instance Methods Abstract Methods Concrete Methods
`abstract Value` `asRealValue()` Downcasts to Value or return null.
`static ValueBase` `cast(IValue value)` Downcasts IValue to ValueBase if possible or returns null.
`abstract java.lang.String` `getValueString()`

### Methods inherited from class org.eclipse.wst.jsdt.chromium.debug.core.model.DebugElementImpl.WithEvaluate

`getEvaluateContext`

### Methods inherited from class org.eclipse.wst.jsdt.chromium.debug.core.model.DebugElementImpl.WithEvaluateBase

`getSuspendedState`

### Methods inherited from class org.eclipse.wst.jsdt.chromium.debug.core.model.DebugElementImpl.WithSuspendedBase

`getConnectedData`

### Methods inherited from class org.eclipse.wst.jsdt.chromium.debug.core.model.DebugElementImpl.WithConnectedBase

`getDebugTarget`

### Methods inherited from class org.eclipse.wst.jsdt.chromium.debug.core.model.DebugElementImpl

`getAdapter, getLaunch, getModelIdentifier`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### ValueBase

    protected ValueBase(EvaluateContext evaluateContext)

### Method Detail

#### cast

    public static ValueBase cast(IValue value)

Downcasts IValue to ValueBase if possible or returns null. This should be used in context where IValue is available, but it's unknown whether it's Chromium value or not. Clients should use this method rather that do instanceof themselves, because the latter is unsafe technique (you cannot track manual downcasts and consequently cannot refactor/manage them).

#### asRealValue

    public abstract Value asRealValue()

Downcasts to Value or return null.

#### getValueString

    public abstract java.lang.String getValueString()